import * as _builder_io_qwik_city from '@builder.io/qwik-city';
import { ActionStore, Cookie, RequestEventAction, RequestEvent, RequestEventBase } from '@builder.io/qwik-city';
import * as _builder_io_qwik from '@builder.io/qwik';
import { JSXOutput, Signal, ResourceReturn } from '@builder.io/qwik';

declare const QInput: _builder_io_qwik.Component<{
    label: string;
    id?: string | undefined;
    name?: string | undefined;
    type?: string | undefined;
    class?: string | undefined;
    value?: string | number | undefined;
    error?: string | undefined;
    pattern?: string | undefined;
    readOnly?: boolean | undefined;
    autoComplete?: string | undefined;
    form?: ActionStore<any, any, any> | undefined;
    onInput$?: ((ev: Event, el: HTMLInputElement) => void) | undefined;
    onChange$?: ((event: Event, element: HTMLInputElement) => any) | undefined;
    disabled?: boolean | undefined;
    reset?: boolean | undefined;
}>;
declare const QHiddenInput: _builder_io_qwik.Component<{
    name: string;
    value: string | number;
}>;
declare const QSelect: _builder_io_qwik.Component<{
    label: string;
    id?: string | undefined;
    name?: string | undefined;
    form?: ActionStore<any, any, any> | undefined;
    value?: string | number | undefined;
    error?: string | string[] | undefined | null;
    pattern?: string | undefined;
    onInput$?: ((event: Event, element: HTMLSelectElement) => any) | undefined;
    onChange$?: ((event: Event, element: HTMLSelectElement) => any) | undefined;
    class?: string | undefined;
    disabled?: boolean | undefined;
    reset?: boolean | undefined;
    options?: {
        label: string;
        value?: string | number | undefined;
    }[] | undefined;
}>;
declare const QButton: _builder_io_qwik.Component<{
    form?: ActionStore<any, any, boolean> | undefined;
}>;
declare const QSpinner: _builder_io_qwik.Component<{
    class?: string | undefined;
}>;
declare const QForm: _builder_io_qwik.Component<{
    action?: ActionStore<any, any, any> | undefined;
    class?: string | undefined;
}>;
declare const QInputSm: _builder_io_qwik.Component<{
    label: string;
    class?: string | undefined;
    id?: string | undefined;
    name?: string | undefined;
    type?: string | undefined;
    value?: string | number | undefined;
    error?: string | undefined;
    pattern?: string | undefined;
    autoComplete?: string | undefined;
    form?: ActionStore<any, any, any> | undefined;
    onInput$?: ((ev: Event, el: HTMLInputElement) => void) | undefined;
    onChange$?: ((event: Event, element: HTMLInputElement) => any) | undefined;
    onClick$?: any;
    disabled?: boolean | undefined;
    readOnly?: boolean | undefined;
    reset?: boolean | undefined;
    button?: string | JSXOutput;
}>;
declare const QTextarea: _builder_io_qwik.Component<{
    label: string;
    class?: string | undefined;
    id?: string | undefined;
    name?: string | undefined;
    value?: string | number | undefined;
    error?: string | undefined;
    pattern?: string | undefined;
    autoComplete?: string | undefined;
    form?: ActionStore<any, any, any> | undefined;
    onInput$?: ((ev: Event, el: HTMLInputElement) => void) | undefined;
    onChange$?: ((event: Event, element: HTMLInputElement) => any) | undefined;
    disabled?: boolean | undefined;
    readOnly?: boolean | undefined;
    reset?: boolean | undefined;
}>;
declare const QModal: _builder_io_qwik.Component<{
    signal: Signal<boolean>;
}>;
declare const QContainer: _builder_io_qwik.Component<{
    class?: string | undefined;
}>;
declare const QPagination: _builder_io_qwik.Component<{
    resource: ResourceReturn<any>;
    page?: Signal<number> | undefined;
}>;
declare const QTable: _builder_io_qwik.Component<{
    resource?: ResourceReturn<any> | undefined;
    page?: Signal<number> | undefined;
    header?: string[] | undefined;
}>;
declare const QTableRow: _builder_io_qwik.Component<unknown>;
declare const QTableCol: _builder_io_qwik.Component<{
    class?: string | undefined;
    colSpan?: number | undefined;
}>;

type QRequestInit = {
    method?: "GET" | "POST" | "PUT" | "DELETE" | "PATCH";
    mode?: "cors" | "no-cors" | "same-origin";
    cache?: "default" | "no-store" | "reload" | "no-cache" | "force-cache" | "only-if-cached";
    credentials?: "omit" | "same-origin" | "include";
    redirect?: "follow" | "error" | "manual";
    referrer?: "no-referrer" | "client";
    referrerPolicy?: "no-referrer" | "no-referrer-when-downgrade" | "origin" | "origin-when-cross-origin" | "same-origin" | "strict-origin" | "strict-origin-when-cross-origin" | "unsafe-url";
    headers?: Record<string, string>;
    body?: BodyInit | null;
};
type QResponse = {
    statusCode: number;
    message: string;
    [key: string]: any | undefined;
};
type QData = Record<string, string | number | boolean> | {
    params?: Record<string, string>;
    body: Record<string, string | number | boolean>;
};
type QEvent = {
    url?: URL;
    request?: {
        headers?: Headers;
    };
    cookie?: Cookie;
} | RequestEventAction | RequestEvent | RequestEventBase;
declare function qfetch(url: string, request?: QRequestInit, event?: QEvent): Promise<Response>;
declare const QFetch: (url: string, request: QRequestInit, event: QEvent) => Promise<QResponse>;
declare function _QData(url: string, data: QData): {
    body: Record<string, string | number | boolean>;
    qurl: string;
};
declare function qget(url: string, data: QData, event: QEvent, request?: QRequestInit): Promise<QResponse>;
declare function qpost(url: string, data: QData, event: QEvent, request?: QRequestInit): Promise<QResponse>;
declare function qput(url: string, data: QData, event: QEvent, request?: QRequestInit): Promise<QResponse>;
declare function qdelete(url: string, data: QData, event: QEvent, request?: QRequestInit): Promise<QResponse>;
declare function qpatch(url: string, data: QData, event: QEvent, request?: QRequestInit): Promise<QResponse>;
declare const _QFetch: _builder_io_qwik_city.ServerQRL<(this: RequestEventBase<QwikCityPlatform>, url: string, request: QRequestInit) => Promise<QResponse>>;
declare function _qget(url: string, data: QData, request?: QRequestInit): Promise<QResponse>;
declare function _qpost(url: string, data: QData, request?: QRequestInit): Promise<QResponse>;
declare function _qput(url: string, data: QData, request?: QRequestInit): Promise<QResponse>;
declare function _qdelete(url: string, data: QData, request?: QRequestInit): Promise<QResponse>;
declare function _qpatch(url: string, data: QData, request?: QRequestInit): Promise<QResponse>;
declare function _qmget(url: string, data: QData, request?: QRequestInit): Promise<any>;
declare function _qsget(url: string, data: QData, request?: QRequestInit): Promise<number>;
type _Qdget = {
    pagination: any;
    results: {
        total: number;
        page: number;
        from: number;
        to: number;
        perPage: number;
    };
    data: any;
    signal: {
        value: number;
    };
};
declare function _qdget(url: string, data: QData, request?: QRequestInit): Promise<_Qdget>;
declare const sget: typeof _qget;
declare const spost: typeof _qpost;
declare const sput: typeof _qput;
declare const sdelete: typeof _qdelete;
declare const spatch: typeof _qpatch;
declare const smget: typeof _qmget;
declare const ssget: typeof _qsget;
declare const sdget: typeof _qdget;

export { QButton, QContainer, type QData, type QEvent, QFetch, QForm, QHiddenInput, QInput, QInputSm, QModal, QPagination, type QRequestInit, type QResponse, QSelect, QSpinner, QTable, QTableCol, QTableRow, QTextarea, _QData, _QFetch, type _Qdget, _qdelete, _qdget, _qget, _qmget, _qpatch, _qpost, _qput, _qsget, qdelete, qfetch, qget, qpatch, qpost, qput, sdelete, sdget, sget, smget, spatch, spost, sput, ssget };
